# Ogre::ImageCodec Class Reference

Codec specialized in images. More...

`#include <OgreImageCodec.h>`

Inheritance diagram for Ogre::ImageCodec:

[legend]
List of all members.

## Public Types

typedef SharedPtr< CodecData > | CodecDataPtr
typedef ConstMapIterator< CodecList > | CodecIterator
typedef std::pair< MemoryDataStreamPtr, CodecDataPtr > | DecodeResult
| Result of a decoding; both a decoded data stream and CodecData metadata.

## Public Member Functions

virtual | ~ImageCodec ()
String | getDataType () const
| Returns the type of the data that supported by this codec as a String.
virtual DataStreamPtr | code (MemoryDataStreamPtr &input, CodecDataPtr &pData) const =0
| Codes the data in the input stream and saves the result in the output stream.
virtual void | codeToFile (MemoryDataStreamPtr &input, const String &outFileName, CodecDataPtr &pData) const =0
| Codes the data in the input chunk and saves the result in the output filename provided.
virtual DecodeResult | decode (DataStreamPtr &input) const =0
| Codes the data from the input chunk into the output chunk.
virtual String | getType () const =0
| Returns the type of the codec as a String.
virtual bool | magicNumberMatch (const char *magicNumberPtr, size_t maxbytes) const
| Returns whether a magic number header matches this codec.
virtual String | magicNumberToFileExt (const char *magicNumberPtr, size_t maxbytes) const =0
| Maps a magic number header to a file extension, if this codec recognises it.
| AllocatedObject ()
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)

## Static Public Member Functions

static void | registerCodec (Codec *pCodec)
| Registers a new codec in the database.
static void | unRegisterCodec (Codec *pCodec)
| Unregisters a codec from the database.
static CodecIterator | getCodecIterator (void)
| Gets the iterator for the registered codecs.
static StringVector | getExtensions (void)
| Gets the file extension list for the registered codecs.
static Codec * | getCodec (const String &extension)
| Gets the codec registered for the passed in file extension.
static Codec * | getCodec (char *magicNumberPtr, size_t maxbytes)
| Gets the codec that can handle the given 'magic' identifier.

## Protected Types

typedef std::map< String, Codec * > | CodecList

## Static Protected Attributes

static CodecList | ms_mapCodecs
| A map that contains all the registered codecs.

## Classes

class | ImageData
| Codec return class for images. More...

## Detailed Description

Codec specialized in images.

Remarks:
  The users implementing subclasses of ImageCodec are required to return a valid pointer to a ImageData class from the decode(...) function.

Definition at line 42 of file OgreImageCodec.h.

## Member Typedef Documentation

typedef SharedPtr<CodecData> Ogre::Codec::CodecDataPtr`[inherited]`

| Definition at line 67 of file OgreCodec.h.

typedef ConstMapIterator<CodecList> Ogre::Codec::CodecIterator`[inherited]`

| Definition at line 69 of file OgreCodec.h.

typedef std::map< String, Codec* > Ogre::Codec::CodecList`[protected, inherited]`

| Definition at line 52 of file OgreCodec.h.

typedef std::pair<MemoryDataStreamPtr, CodecDataPtr> Ogre::Codec::DecodeResult`[inherited]`

| Result of a decoding; both a decoded data stream and CodecData metadata. Definition at line 122 of file OgreCodec.h.

## Constructor & Destructor Documentation

virtual Ogre::ImageCodec::~ImageCodec | ( |  | ) | `[virtual]`

## Member Function Documentation

Ogre::AllocatedObject< GeneralAllocPolicy >::AllocatedObject | ( |  | ) | `[explicit, inherited]`

| Definition at line 55 of file OgreMemoryAllocatedObject.h.

virtual DataStreamPtr Ogre::Codec::code | ( | MemoryDataStreamPtr & | input,
|  | CodecDataPtr & | pData
| ) | const`[pure virtual, inherited]`

| Codes the data in the input stream and saves the result in the output stream. Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, and Ogre::ILImageCodec.

virtual void Ogre::Codec::codeToFile | ( | MemoryDataStreamPtr & | input,
|  | const String & | outFileName,
|  | CodecDataPtr & | pData
| ) | const`[pure virtual, inherited]`

Codes the data in the input chunk and saves the result in the output filename provided.

Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations.

Parameters:

  | input | The input data
  | outFileName | The filename to write to
  | pData | Extra information to be passed to the codec (codec type specific)

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, and Ogre::ILImageCodec.

virtual DecodeResult Ogre::Codec::decode | ( | DataStreamPtr & | input | ) | const`[pure virtual, inherited]`

Codes the data from the input chunk into the output chunk.

Parameters:

  | input | Stream containing the encoded data

Note:
  Has a variable number of arguments, which depend on the codec type.

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, and Ogre::ILImageCodec.

static Codec* Ogre::Codec::getCodec | ( | char * | magicNumberPtr,
|  | size_t | maxbytes
| ) | `[static, inherited]`

Gets the codec that can handle the given 'magic' identifier.

Parameters:

  | magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  | maxbytes | The number of bytes passed

static Codec* Ogre::Codec::getCodec | ( | const String & | extension | ) | `[static, inherited]`

| Gets the codec registered for the passed in file extension.

static CodecIterator Ogre::Codec::getCodecIterator | ( | void |  | ) | `[static, inherited]`

| Gets the iterator for the registered codecs. Definition at line 89 of file OgreCodec.h.

String Ogre::ImageCodec::getDataType | ( |  | ) | const`[virtual]`

| Returns the type of the data that supported by this codec as a String. Implements Ogre::Codec. Definition at line 74 of file OgreImageCodec.h.

static StringVector Ogre::Codec::getExtensions | ( | void |  | ) | `[static, inherited]`

| Gets the file extension list for the registered codecs.

virtual String Ogre::Codec::getType | ( |  | ) | const`[pure virtual, inherited]`

| Returns the type of the codec as a String. Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, and Ogre::ILImageCodec. Referenced by Ogre::Codec::registerCodec(), and Ogre::Codec::unRegisterCodec().

virtual bool Ogre::Codec::magicNumberMatch | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes
| ) | const`[virtual, inherited]`

Returns whether a magic number header matches this codec.

Parameters:

  | magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  | maxbytes | The number of bytes passed

Definition at line 144 of file OgreCodec.h.

virtual String Ogre::Codec::magicNumberToFileExt | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes
| ) | const`[pure virtual, inherited]`

Maps a magic number header to a file extension, if this codec recognises it.

Parameters:

  | magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  | maxbytes | The number of bytes passed

Returns:
  A blank string if the magic number was unknown, or a file extension.

Implemented in Ogre::DDSCodec, Ogre::FreeImageCodec, and Ogre::ILImageCodec.

void Ogre::AllocatedObject< GeneralAllocPolicy >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) | `[inherited]`

| Definition at line 101 of file OgreMemoryAllocatedObject.h.

void Ogre::AllocatedObject< GeneralAllocPolicy >::operator delete | ( | void * | ptr,
|  | void * |
| ) | `[inherited]`

| Definition at line 95 of file OgreMemoryAllocatedObject.h.

void Ogre::AllocatedObject< GeneralAllocPolicy >::operator delete | ( | void * | ptr | ) | `[inherited]`

| Definition at line 89 of file OgreMemoryAllocatedObject.h.

void Ogre::AllocatedObject< GeneralAllocPolicy >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) | `[inherited]`

| Definition at line 112 of file OgreMemoryAllocatedObject.h.

void Ogre::AllocatedObject< GeneralAllocPolicy >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

| Definition at line 106 of file OgreMemoryAllocatedObject.h.

void* Ogre::AllocatedObject< GeneralAllocPolicy >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) | `[inherited]`

| placement operator new Definition at line 73 of file OgreMemoryAllocatedObject.h.

void* Ogre::AllocatedObject< GeneralAllocPolicy >::operator new | ( | size_t | sz | ) | `[inherited]`

| Definition at line 67 of file OgreMemoryAllocatedObject.h.

void* Ogre::AllocatedObject< GeneralAllocPolicy >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) | `[inherited]`

| operator new, with debug line info Definition at line 62 of file OgreMemoryAllocatedObject.h.

void* Ogre::AllocatedObject< GeneralAllocPolicy >::operator new[] | ( | size_t | sz | ) | `[inherited]`

| Definition at line 84 of file OgreMemoryAllocatedObject.h.

void* Ogre::AllocatedObject< GeneralAllocPolicy >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) | `[inherited]`

| array operator new, with debug line info Definition at line 79 of file OgreMemoryAllocatedObject.h.

static void Ogre::Codec::registerCodec | ( | Codec * | pCodec | ) | `[static, inherited]`

| Registers a new codec in the database. Definition at line 76 of file OgreCodec.h. References Ogre::Codec::getType().

static void Ogre::Codec::unRegisterCodec | ( | Codec * | pCodec | ) | `[static, inherited]`

| Unregisters a codec from the database. Definition at line 83 of file OgreCodec.h. References Ogre::Codec::getType().

## Member Data Documentation

CodecList Ogre::Codec::ms_mapCodecs`[static, protected, inherited]`

| A map that contains all the registered codecs. Definition at line 55 of file OgreCodec.h.

The documentation for this class was generated from the following file:

- OgreImageCodec.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sat Apr 11 13:48:31 2009